/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     FLOW = 258,
     FLOWSET = 259,
     ESTIMATOR = 260,
     DCOUNTER = 261,
     PCOUNTER = 262,
     ALIAS = 263,
     SEED = 264,
     SEND = 265,
     RECV = 266,
     UDP = 267,
     TCP = 268,
     CBR = 269,
     TRACE = 270,
     PARETO = 271,
     GREEDY = 272,
     MAP = 273,
     FIXED = 274,
     REPEAT = 275,
     AT = 276,
     VARY = 277,
     SERVER = 278,
     STAMP = 279,
     RSVP_S = 280,
     WTP = 281,
     RATE = 282,
     DELAY = 283,
     PACKETS = 284,
     SYNC = 285,
     INTEGER = 286,
     FLOAT = 287,
     STRING = 288,
     IP_ADDRESS = 289
   };
#endif
#define FLOW 258
#define FLOWSET 259
#define ESTIMATOR 260
#define DCOUNTER 261
#define PCOUNTER 262
#define ALIAS 263
#define SEED 264
#define SEND 265
#define RECV 266
#define UDP 267
#define TCP 268
#define CBR 269
#define TRACE 270
#define PARETO 271
#define GREEDY 272
#define MAP 273
#define FIXED 274
#define REPEAT 275
#define AT 276
#define VARY 277
#define SERVER 278
#define STAMP 279
#define RSVP_S 280
#define WTP 281
#define RATE 282
#define DELAY 283
#define PACKETS 284
#define SYNC 285
#define INTEGER 286
#define FLOAT 287
#define STRING 288
#define IP_ADDRESS 289




/* Copy the first part of user declarations.  */
#line 31 "unix/tg_parser.y"


#include "tg_classes.h"

using namespace TG;

extern int yyparse();
extern int yylex();
extern int yylineno;
extern void yyerror(const char*);
extern FILE* yyin;
extern String yy_string;
extern uint32 yy_int;
extern ieee32float_p yy_float;

static String yy_ip_address;
static TimeValue yy_timeval;
static String yy_name;
static RSVP_API* api = NULL;
static TSpec tspec;
static TimeValue rsvpSignalWaitTime;
static TimeValue rsvpSyncBackoffTime;
static RSpec rspec;
static bool stamp,rsvp,flowMapping;
static uint32 flowCount, createCount;
static NetAddress localAddr,remoteAddr;
static uint16 localPort, remotePort;
static uint32 packetRate,packetSize,totalSize,sourceCount;
static double hurstParameter,wtpFactor;
static TimeValue flowArrival,flowDuration;
static enum FlowType { tg_UDP, tg_TCP, tg_TCP_Server } flowType;
static enum SenderType { tg_CBR, tg_TRACE, tg_PARETO, tg_GREEDY } senderType;
static ActionObject* action = NULL;
static Flow* flow = NULL;
static Flow** flows = NULL;
static RateEstimator* rateEstimator = NULL;
static DelayCounter* delayCounter = NULL;
static PacketCounter* packetCounter = NULL;
static SimpleList<uint32> varList;
static TimeValue varTime, cbrTime, connectTime;
static bool fixedArrival, fixedDuration;
static bool syntaxError = true, fatalError = false;
static const char* configfile = NULL;

static void createSummaryObject( SummaryObject& so ) {
	if ( traffgen->getSummaryObject( so.getName() ) ) {
		cerr << "ERROR: summary object " << so.getName() << "already exists" << endl;
		exit(1);
	}
	traffgen->addSummaryObject( so );
}

static SummaryObject* findSummaryObject( const String& name ) {
	SummaryObject* so = traffgen->getSummaryObject( name );
	if ( !so ) {
		cerr << "WARNING: cannot find summary object named " << name << endl;
	}
	return so;
}

struct Alias {
	String name;
	String addr;
	Alias( const String& n = "", const String& a = "" ) : name(n), addr(a) {}
};
static SimpleList<Alias> aliasList;

static void findAlias( const String& name ) {
	SimpleList<Alias>::ConstIterator iter = aliasList.begin();
	for ( ; iter != aliasList.end(); ++iter ) {
		if ( (*iter).name == name ) {
			yy_ip_address = (*iter).addr;
			return;
		}
	}
	yy_ip_address = name;
}

static void cleanup() {
	flows = NULL;
	flow = NULL;
	action = NULL;
}
static void doSendFlow() {
	if ( stamp ) flow->enableSenderTimestamping();
	if ( rsvp && api ) reinterpret_cast<Sender*>(action)->enableSignallingRSVP( *api, tspec, rsvpSignalWaitTime, rsvpSyncBackoffTime );
	if ( rateEstimator ) flow->attachSendingRateEstimator( *rateEstimator );
	if ( packetCounter ) flow->attachSendPacketCounter( *packetCounter );
}
static void doReceiveFlow() {
	if ( stamp ) flow->enableReceiverTimestamping();
	if ( rsvp && api ) flow->signalReceiverRSVP( *api, rspec, wtpFactor );
	if ( rateEstimator ) flow->attachReceivingRateEstimator( *rateEstimator );
	if ( delayCounter ) flow->attachDelayCounter( *delayCounter );
	traffgen->addFlow( *flow );
}
static void finishFlowset() {
	uint32 i = 0;
	for ( ; i < flowCount; ++i ) {
		traffgen->addFlowHousekeeping( *flows[i] );
	}
	delete [] flows;
	flows = NULL;
}
static void doReceiveFlowset() {
	uint32 i = 0;
	for ( ; i < flowCount; ++i ) {
		traffgen->addFlow( *flows[i] );
		if ( stamp ) flows[i]->enableReceiverTimestamping();
		if ( rsvp && api ) {
			flows[i]->signalReceiverRSVP( *api, rspec, wtpFactor );
			if (i/10 == 0) usleep(1000);
		}
		if ( rateEstimator ) flows[i]->attachReceivingRateEstimator( *rateEstimator );
		if ( delayCounter ) flows[i]->attachDelayCounter( *delayCounter );
	}
}
static void doSendFlowset() {
	ActionSet* as = new ActionSet( createCount, flowArrival, flowDuration, fixedArrival, fixedDuration );
	uint32 i = 0;
	uint32 avgFlowCount = (uint32)(flowDuration/flowArrival);
	if ( createCount > flowCount && avgFlowCount * 1.5 > flowCount ) {
		LOG(4)( LogWarning, "WARNING: estimated avg. flow count is", avgFlowCount, "given flow count:", flowCount );
	}
	for ( ; i < flowCount; ++i ) {
                                                             assert(flows[i]);
		Sender* s;
		if ( senderType == tg_CBR ) {
			s = new CbrSender( *flows[i], packetSize, packetRate, TimeValue( 0, 0 ) );
		} else if ( senderType == tg_TRACE ) {
			s = new TraceSender( *flows[i], yy_string );
		} else if ( senderType == tg_PARETO ) {
			s = new ParetoSender( *flows[i], packetSize, packetRate, TimeValue( 0, 0 ), sourceCount, hurstParameter );
		} else {
			s = new GreedySender( *flows[i], packetSize, packetRate, totalSize, TimeValue( 0, 0 ) );
		}
		traffgen->addActionHousekeeping( *s );
		as->addAction( *s );
		if ( stamp ) flows[i]->enableSenderTimestamping();
		if ( rsvp && api ) s->enableSignallingRSVP( *api, tspec, rsvpSignalWaitTime, rsvpSyncBackoffTime );
		if ( rateEstimator ) flows[i]->attachSendingRateEstimator( *rateEstimator );
		if ( packetCounter ) flows[i]->attachSendPacketCounter( *packetCounter );
	}
	if ( flowMapping && rsvp && api ) {
		Flowset* flowset = new Flowset( localPort, flowCount);
		flowset->flows[0] = flows[0];
		RSVP_API::SessionId id = flows[0]->registerSenderRSVP( *api, flowset );
		for ( i = 1; i < flowCount; ++i ) {
			flows[i]->setRSVP( *api, id );
			flowset->flows[i] = flows[i];
		}
		
	}
	action = as;
}
static void doCreateFlowset() {
	flows = new Flow*[flowCount];
	uint32 i = 0;
	for ( ; i < flowCount; ++i ) {
		switch ( flowType ) {
		case tg_UDP:
			if ( flowMapping ) {
				flows[i] = new UdpFlow( localAddr.rawAddress(), localPort + i, remoteAddr.rawAddress(), remotePort );
			} else {
				flows[i] = new UdpFlow( localAddr.rawAddress(), localPort + i, remoteAddr.rawAddress(), remotePort + i );
			}
			break;
		case tg_TCP:
			if ( flowMapping ) {
				flows[i] = new TcpFlow( localAddr.rawAddress(), remoteAddr.rawAddress(), remotePort, connectTime );
			} else {
				flows[i] = new TcpFlow( localAddr.rawAddress(), remoteAddr.rawAddress(), remotePort + i, connectTime );
			}
			break;
		case tg_TCP_Server:
			flows[i] = new TcpServer( localAddr.rawAddress(), localPort + i );
			break;
		default:
			assert(0);
		}
	}
}
static void createCbrVariation() {
	CbrSender* sender = new CbrSender( *flow, packetSize, packetRate, cbrTime );
	traffgen->addActionHousekeeping( *sender );
	SenderVariation* sv = new SenderVariation( *sender, varTime );
	sv->addPacketRates(varList);
	varList.clear();
	action = sv;
}
static bool checkLocalAddress() {
	if ( !traffgen->findInterface(localAddr.rawAddress()) ) {
		cerr << "ignoring unknown local address: " << localAddr << endl;
		syntaxError = false;
		return false;
	}
	return true;
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 356 "/home/oscars/dcn-software-suite-0.5.1/dragon/dragon-sw/kom-rsvp/gen/clients/tg_parser.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   173

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  35
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  62
/* YYNRULES -- Number of rules. */
#define YYNRULES  116
/* YYNRULES -- Number of states. */
#define YYNSTATES  203

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   289

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     6,     7,     9,    11,    13,    15,    17,
      19,    22,    24,    29,    33,    37,    43,    49,    53,    57,
      63,    68,    72,    77,    84,    89,    92,    99,   105,   108,
     111,   112,   115,   118,   123,   127,   131,   137,   143,   148,
     154,   161,   168,   174,   183,   191,   194,   199,   204,   211,
     213,   215,   218,   220,   221,   224,   226,   228,   229,   231,
     232,   237,   242,   243,   245,   248,   249,   255,   256,   258,
     260,   262,   264,   266,   268,   270,   272,   276,   279,   282,
     283,   285,   287,   289,   292,   295,   296,   299,   300,   303,
     304,   307,   308,   310,   312,   314,   316,   318,   321,   324,
     326,   328,   330,   332,   333,   335,   336,   338,   339,   341,
     343,   345,   347,   351,   353,   357,   362
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      36,     0,    -1,    36,    37,    -1,    -1,    38,    -1,    46,
      -1,    92,    -1,    94,    -1,    95,    -1,    96,    -1,     9,
      31,    -1,     1,    -1,     3,    40,    41,    44,    -1,     3,
      39,    43,    -1,     3,    40,    43,    -1,     3,    40,    43,
      41,    44,    -1,     3,    40,    41,    44,    43,    -1,    13,
      23,    56,    -1,    12,    56,    58,    -1,    12,    56,    58,
      57,    31,    -1,    13,    59,    58,    60,    -1,    10,    42,
      51,    -1,    14,    78,    79,    90,    -1,    14,    78,    79,
      90,    22,    83,    -1,    14,    78,    79,    33,    -1,    15,
      33,    -1,    16,    78,    79,    90,    81,    82,    -1,    17,
      78,    79,    80,    90,    -1,    11,    52,    -1,    45,    44,
      -1,    -1,    20,    31,    -1,    21,    90,    -1,     4,    48,
      49,    44,    -1,     4,    47,    50,    -1,     4,    48,    50,
      -1,     4,    48,    50,    49,    44,    -1,     4,    48,    49,
      44,    50,    -1,    55,    13,    23,    56,    -1,    55,    12,
      56,    57,    58,    -1,    55,    13,    59,    57,    58,    60,
      -1,    10,    14,    78,    79,    53,    51,    -1,    10,    15,
      33,    53,    51,    -1,    10,    16,    78,    79,    81,    82,
      53,    51,    -1,    10,    17,    78,    79,    80,    53,    51,
      -1,    11,    52,    -1,    61,    75,    77,    62,    -1,    61,
      75,    76,    71,    -1,    88,    85,    89,    86,    87,    54,
      -1,    31,    -1,    31,    -1,    91,    31,    -1,    18,    -1,
      -1,    91,    31,    -1,    91,    -1,    90,    -1,    -1,    24,
      -1,    -1,    25,    63,    65,    64,    -1,    25,    63,    65,
      30,    -1,    -1,    90,    -1,    30,    90,    -1,    -1,    66,
      67,    68,    69,    70,    -1,    -1,    32,    -1,    31,    -1,
      32,    -1,    31,    -1,    32,    -1,    31,    -1,    31,    -1,
      31,    -1,    25,    72,    73,    -1,    25,    31,    -1,    25,
      74,    -1,    -1,    32,    -1,    31,    -1,    31,    -1,    26,
      32,    -1,    26,    31,    -1,    -1,    27,    33,    -1,    -1,
      28,    33,    -1,    -1,    29,    33,    -1,    -1,    31,    -1,
      31,    -1,    31,    -1,    31,    -1,    32,    -1,    90,    84,
      -1,    84,    31,    -1,    31,    -1,    90,    -1,    90,    -1,
      19,    -1,    -1,    19,    -1,    -1,    19,    -1,    -1,    31,
      -1,    32,    -1,    34,    -1,    33,    -1,     8,    93,    91,
      -1,    33,    -1,     5,    33,    90,    -1,     6,    33,    90,
      31,    -1,     7,    33,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   240,   240,   241,   245,   246,   247,   248,   249,   250,
     251,   252,   256,   257,   258,   259,   260,   264,   268,   269,
     270,   274,   278,   279,   280,   281,   282,   283,   287,   291,
     292,   296,   297,   301,   302,   303,   304,   305,   309,   313,
     314,   318,   319,   320,   321,   325,   329,   333,   337,   341,
     345,   349,   353,   354,   358,   362,   366,   367,   371,   372,
     376,   377,   378,   382,   386,   387,   391,   392,   396,   397,
     401,   402,   406,   407,   411,   415,   419,   420,   421,   422,
     426,   427,   431,   435,   436,   437,   441,   442,   446,   447,
     451,   452,   456,   460,   464,   468,   472,   476,   480,   481,
     485,   489,   493,   494,   498,   499,   503,   504,   508,   509,
     513,   514,   518,   522,   526,   530,   534
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FLOW", "FLOWSET", "ESTIMATOR",
  "DCOUNTER", "PCOUNTER", "ALIAS", "SEED", "SEND", "RECV", "UDP", "TCP",
  "CBR", "TRACE", "PARETO", "GREEDY", "MAP", "FIXED", "REPEAT", "AT",
  "VARY", "SERVER", "STAMP", "RSVP_S", "WTP", "RATE", "DELAY", "PACKETS",
  "SYNC", "INTEGER", "FLOAT", "STRING", "IP_ADDRESS", "$accept", "program",
  "command", "flow_command", "ext_flow_descr", "flow_descr", "flow_send",
  "sendertype", "flow_recv", "add_actions", "add_action",
  "flowset_command", "ext_flowset_descr", "flowset_descr", "flowset_send",
  "flowset_recv", "send_conf", "recv_conf", "fs_conf", "create_count",
  "flowcount", "local", "map", "remote", "local_addr", "connect_time",
  "stamp", "rsvp_send", "rsvpwait", "sync", "tspec", "avg", "depth",
  "peak", "min", "MTU", "rsvp_recv", "rate", "slack", "wtp",
  "rate_estimator", "dcounter", "pcounter", "packetsize", "packetrate",
  "totalsize", "srccount", "hurst", "vary", "variation", "arrival",
  "duration", "fixed", "fixed_a", "fixed_d", "timeval", "ip_address",
  "alias_command", "name", "estimator_command", "dcounter_command",
  "pcounter_command", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    35,    36,    36,    37,    37,    37,    37,    37,    37,
      37,    37,    38,    38,    38,    38,    38,    39,    40,    40,
      40,    41,    42,    42,    42,    42,    42,    42,    43,    44,
      44,    45,    45,    46,    46,    46,    46,    46,    47,    48,
      48,    49,    49,    49,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    57,    58,    59,    60,    60,    61,    61,
      62,    62,    62,    63,    64,    64,    65,    65,    66,    66,
      67,    67,    68,    68,    69,    70,    71,    71,    71,    71,
      72,    72,    73,    74,    74,    74,    75,    75,    76,    76,
      77,    77,    78,    79,    80,    81,    82,    83,    84,    84,
      85,    86,    87,    87,    88,    88,    89,    89,    90,    90,
      91,    91,    92,    93,    94,    95,    96
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     0,     1,     1,     1,     1,     1,     1,
       2,     1,     4,     3,     3,     5,     5,     3,     3,     5,
       4,     3,     4,     6,     4,     2,     6,     5,     2,     2,
       0,     2,     2,     4,     3,     3,     5,     5,     4,     5,
       6,     6,     5,     8,     7,     2,     4,     4,     6,     1,
       1,     2,     1,     0,     2,     1,     1,     0,     1,     0,
       4,     4,     0,     1,     2,     0,     5,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     2,     2,     0,
       1,     1,     1,     2,     2,     0,     2,     0,     2,     0,
       2,     0,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     0,     1,     0,     1,     0,     1,     1,
       1,     1,     3,     1,     3,     4,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       3,     0,     1,    11,     0,     0,     0,     0,     0,     0,
       0,     2,     4,     5,     6,     7,     8,     9,     0,     0,
       0,     0,    50,     0,     0,     0,     0,     0,   116,   113,
       0,    10,   111,   110,     0,     0,     0,     0,    55,    59,
      13,     0,    30,    14,    59,    34,     0,    30,    35,     0,
       0,   108,   109,   114,     0,   112,    18,     0,    51,    17,
      57,    58,    28,    87,     0,     0,     0,     0,    59,     0,
       0,    12,    30,    30,    45,     0,     0,     0,     0,    33,
      30,    53,     0,    53,   115,    52,     0,    54,    20,    56,
       0,    89,    92,     0,    25,     0,     0,    21,    87,    31,
      32,    16,    29,    15,     0,   105,     0,     0,    37,    36,
       0,    38,     0,    19,    86,     0,    79,    93,     0,     0,
       0,    91,   105,   104,    59,     0,     0,     0,    39,    57,
      88,    85,    47,    24,    22,     0,    94,     0,     0,    62,
      59,    42,   107,   100,    95,     0,   105,    40,     0,    77,
      80,     0,    78,     0,     0,    27,    90,     0,    46,    41,
     106,     0,    96,   105,    59,    84,    83,    82,    76,    23,
       0,    26,    67,    63,   103,   101,    59,    44,    99,    97,
      69,    68,    65,     0,   102,     0,    43,    98,    61,    60,
      71,    70,     0,    49,    48,    64,    73,    72,     0,    74,
       0,    75,    66
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,    11,    12,    20,    21,    42,    68,    40,    71,
      72,    13,    23,    24,    47,    45,    97,    62,   124,   194,
      25,    34,    86,    56,    37,    88,    98,   158,   172,   189,
     182,   183,   192,   198,   200,   202,   132,   151,   168,   152,
      91,   116,   139,    93,   118,   137,   145,   163,   169,   179,
     142,   174,   185,   125,   161,    89,    35,    14,    30,    15,
      16,    17
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -119
static const yysigned_char yypact[] =
{
    -119,    62,  -119,  -119,     7,   -18,     0,     2,    10,    18,
      29,  -119,  -119,  -119,  -119,  -119,  -119,  -119,    -9,    -7,
      53,    78,  -119,    61,    80,    85,    69,    69,  -119,  -119,
      -9,  -119,  -119,  -119,    -9,    43,    -9,    -9,  -119,    52,
    -119,    66,    82,   100,    52,  -119,    70,    82,   104,    -9,
       6,  -119,  -119,  -119,    64,  -119,    -8,    84,  -119,  -119,
      69,  -119,  -119,    89,    86,    87,    86,    86,    52,    88,
      69,    53,    82,    82,  -119,    86,    90,    86,    86,    61,
      82,   103,    -9,   103,  -119,  -119,    91,  -119,  -119,  -119,
      92,    96,  -119,    95,  -119,    95,    95,  -119,    89,  -119,
    -119,  -119,  -119,  -119,    95,    99,    95,    95,  -119,  -119,
      -9,  -119,    -9,  -119,  -119,    97,   107,  -119,    23,    69,
      98,   105,    99,  -119,    52,    69,   102,    98,  -119,    69,
    -119,    47,  -119,  -119,   106,   102,  -119,    69,   108,   111,
      52,  -119,   118,  -119,  -119,   110,    99,  -119,    73,   109,
    -119,   112,  -119,    69,   110,  -119,  -119,    69,  -119,  -119,
    -119,    69,  -119,    99,    52,  -119,  -119,  -119,  -119,  -119,
     113,  -119,    75,  -119,   119,  -119,    52,  -119,  -119,   114,
    -119,  -119,   116,    77,  -119,   117,  -119,  -119,    69,  -119,
    -119,  -119,    81,  -119,  -119,  -119,  -119,  -119,   120,  -119,
     121,  -119,  -119
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
    -119,  -119,  -119,  -119,  -119,  -119,   115,  -119,   -14,   -42,
    -119,  -119,  -119,  -119,   101,   -20,  -118,   122,  -114,  -119,
    -119,   -21,   -72,   -35,   123,    21,   -27,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
      41,  -119,  -119,   -30,   -54,    20,    19,    -1,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,   -26,   -16,  -119,  -119,  -119,
    -119,  -119
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -82
static const short yytable[] =
{
      53,    54,    60,    38,    48,    79,   141,    43,   140,   110,
      85,   112,    63,    22,    55,    59,    36,    63,    57,    18,
      19,    57,   159,   -53,    32,    33,    32,    33,    81,    82,
     102,   103,   164,    26,    38,    27,    95,    96,   109,    32,
      33,   119,   120,    28,   100,   104,   177,   106,   107,   176,
     122,    29,   126,   127,    51,    52,   133,   101,   186,   108,
      31,   111,     2,     3,    39,     4,     5,     6,     7,     8,
       9,    10,    44,   148,    58,   128,    61,   129,   149,   150,
      64,    65,    66,    67,    75,    76,    77,    78,    41,    39,
      46,    44,   134,   135,    57,    84,    57,    49,    50,   143,
      51,    52,    69,    70,   165,   166,   180,   181,   190,   191,
      41,   155,   196,   197,    46,    87,    90,    92,   123,    99,
      94,    85,   113,   105,   115,   114,   117,   170,   153,   136,
     130,   173,   131,   144,   138,   175,   157,   160,   184,   121,
     -81,   156,   162,   167,   178,   187,   188,   146,   193,    80,
     147,   199,   201,   171,   154,     0,     0,     0,    73,     0,
       0,     0,   195,     0,     0,     0,    74,     0,     0,     0,
       0,     0,     0,    83
};

static const short yycheck[] =
{
      26,    27,    37,    19,    24,    47,   124,    21,   122,    81,
      18,    83,    39,    31,    30,    36,    23,    44,    34,    12,
      13,    37,   140,    31,    33,    34,    33,    34,    49,    23,
      72,    73,   146,    33,    50,    33,    66,    67,    80,    33,
      34,    95,    96,    33,    70,    75,   164,    77,    78,   163,
     104,    33,   106,   107,    31,    32,    33,    71,   176,    79,
      31,    82,     0,     1,    11,     3,     4,     5,     6,     7,
       8,     9,    11,    26,    31,   110,    24,   112,    31,    32,
      14,    15,    16,    17,    14,    15,    16,    17,    10,    11,
      10,    11,   118,   119,   110,    31,   112,    12,    13,   125,
      31,    32,    20,    21,    31,    32,    31,    32,    31,    32,
      10,   137,    31,    32,    10,    31,    27,    31,    19,    31,
      33,    18,    31,    33,    28,    33,    31,   153,    22,    31,
      33,   157,    25,    31,    29,   161,    25,    19,    19,    98,
      31,    33,    32,    31,    31,    31,    30,   127,    31,    48,
     129,    31,    31,   154,   135,    -1,    -1,    -1,    43,    -1,
      -1,    -1,   188,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    50
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    36,     0,     1,     3,     4,     5,     6,     7,     8,
       9,    37,    38,    46,    92,    94,    95,    96,    12,    13,
      39,    40,    31,    47,    48,    55,    33,    33,    33,    33,
      93,    31,    33,    34,    56,    91,    23,    59,    91,    11,
      43,    10,    41,    43,    11,    50,    10,    49,    50,    12,
      13,    31,    32,    90,    90,    91,    58,    91,    31,    56,
      58,    24,    52,    61,    14,    15,    16,    17,    42,    20,
      21,    44,    45,    41,    52,    14,    15,    16,    17,    44,
      49,    56,    23,    59,    31,    18,    57,    31,    60,    90,
      27,    75,    31,    78,    33,    78,    78,    51,    61,    31,
      90,    43,    44,    44,    78,    33,    78,    78,    50,    44,
      57,    56,    57,    31,    33,    28,    76,    31,    79,    79,
      79,    75,    79,    19,    53,    88,    79,    79,    58,    58,
      33,    25,    71,    33,    90,    90,    31,    80,    29,    77,
      53,    51,    85,    90,    31,    81,    80,    60,    26,    31,
      32,    72,    74,    22,    81,    90,    33,    25,    62,    51,
      19,    89,    32,    82,    53,    31,    32,    31,    73,    83,
      90,    82,    63,    90,    86,    90,    53,    51,    31,    84,
      31,    32,    65,    66,    19,    87,    51,    31,    30,    64,
      31,    32,    67,    31,    54,    90,    31,    32,    68,    31,
      69,    31,    70
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 240 "unix/tg_parser.y"
    { if (action) { traffgen->addActionHousekeeping( *action ); traffgen->addAction( *action ); } cleanup(); }
    break;

  case 4:
#line 245 "unix/tg_parser.y"
    { traffgen->addFlowHousekeeping( *flow ); }
    break;

  case 5:
#line 246 "unix/tg_parser.y"
    { finishFlowset(); }
    break;

  case 10:
#line 251 "unix/tg_parser.y"
    { traffgen->setRandomSeed( yy_int ); }
    break;

  case 11:
#line 252 "unix/tg_parser.y"
    { if (syntaxError) yyerror("error"); else syntaxError = true; }
    break;

  case 17:
#line 264 "unix/tg_parser.y"
    { flow = new TcpServer( localAddr.rawAddress(), localPort ); }
    break;

  case 18:
#line 268 "unix/tg_parser.y"
    { flow = new UdpFlow( localAddr.rawAddress(), localPort, remoteAddr.rawAddress(), remotePort ); }
    break;

  case 19:
#line 269 "unix/tg_parser.y"
    { flow = new UdpFlow( localAddr.rawAddress(), localPort, remoteAddr.rawAddress(), remotePort, yy_int ); }
    break;

  case 20:
#line 270 "unix/tg_parser.y"
    { flow = new TcpFlow( localAddr.rawAddress(), remoteAddr.rawAddress(), remotePort, connectTime ); }
    break;

  case 21:
#line 274 "unix/tg_parser.y"
    { doSendFlow(); }
    break;

  case 22:
#line 278 "unix/tg_parser.y"
    { action = new CbrSender( *flow, packetSize, packetRate, yy_timeval ); }
    break;

  case 23:
#line 279 "unix/tg_parser.y"
    { cbrTime = yy_timeval; createCbrVariation(); }
    break;

  case 24:
#line 280 "unix/tg_parser.y"
    { action = new CbrSender( *flow, packetSize, packetRate, yy_string ); }
    break;

  case 25:
#line 281 "unix/tg_parser.y"
    { action = new TraceSender( *flow, yy_string ); }
    break;

  case 26:
#line 282 "unix/tg_parser.y"
    { action = new ParetoSender( *flow, packetSize, packetRate, yy_timeval, sourceCount, hurstParameter ); }
    break;

  case 27:
#line 283 "unix/tg_parser.y"
    { action = new GreedySender( *flow, packetSize, packetRate, totalSize, yy_timeval ); }
    break;

  case 28:
#line 287 "unix/tg_parser.y"
    { doReceiveFlow(); }
    break;

  case 31:
#line 296 "unix/tg_parser.y"
    { assert(action); ActionObject* saveAction = action; action = new RepeatAction( *saveAction, yy_int ); traffgen->addActionHousekeeping( *saveAction ); }
    break;

  case 32:
#line 297 "unix/tg_parser.y"
    { assert(action); ActionObject* saveAction = action; action = new DelayAction( *saveAction, yy_timeval ); traffgen->addActionHousekeeping( *saveAction ); }
    break;

  case 38:
#line 309 "unix/tg_parser.y"
    { flowType = tg_TCP_Server; doCreateFlowset(); }
    break;

  case 39:
#line 313 "unix/tg_parser.y"
    { flowType = tg_UDP; doCreateFlowset(); }
    break;

  case 40:
#line 314 "unix/tg_parser.y"
    { flowType = tg_TCP; doCreateFlowset(); }
    break;

  case 41:
#line 318 "unix/tg_parser.y"
    { senderType = tg_CBR; doSendFlowset(); }
    break;

  case 42:
#line 319 "unix/tg_parser.y"
    { senderType = tg_TRACE; doSendFlowset(); }
    break;

  case 43:
#line 320 "unix/tg_parser.y"
    { senderType = tg_PARETO; doSendFlowset(); }
    break;

  case 44:
#line 321 "unix/tg_parser.y"
    { senderType = tg_GREEDY; doSendFlowset(); }
    break;

  case 45:
#line 325 "unix/tg_parser.y"
    { doReceiveFlowset(); }
    break;

  case 46:
#line 329 "unix/tg_parser.y"
    { delayCounter = NULL; }
    break;

  case 47:
#line 333 "unix/tg_parser.y"
    { packetCounter = NULL; }
    break;

  case 49:
#line 341 "unix/tg_parser.y"
    { createCount = yy_int; }
    break;

  case 50:
#line 345 "unix/tg_parser.y"
    { flowCount = yy_int; }
    break;

  case 51:
#line 349 "unix/tg_parser.y"
    { localAddr = yy_ip_address; localPort = yy_int; if ( !checkLocalAddress() ) YYERROR; }
    break;

  case 52:
#line 353 "unix/tg_parser.y"
    { flowMapping = true; }
    break;

  case 53:
#line 354 "unix/tg_parser.y"
    { flowMapping = false; }
    break;

  case 54:
#line 358 "unix/tg_parser.y"
    { remoteAddr = yy_ip_address; remotePort = yy_int; }
    break;

  case 55:
#line 362 "unix/tg_parser.y"
    { localAddr = yy_ip_address; if ( !checkLocalAddress() ) YYERROR; }
    break;

  case 56:
#line 366 "unix/tg_parser.y"
    { connectTime = yy_timeval; }
    break;

  case 57:
#line 367 "unix/tg_parser.y"
    { connectTime = TimeValue(0,0); }
    break;

  case 58:
#line 371 "unix/tg_parser.y"
    { stamp = true; }
    break;

  case 59:
#line 372 "unix/tg_parser.y"
    { stamp = false; }
    break;

  case 60:
#line 376 "unix/tg_parser.y"
    { rsvp = true; }
    break;

  case 61:
#line 377 "unix/tg_parser.y"
    { rsvp = true; rsvpSyncBackoffTime = TimeValue(0,0); }
    break;

  case 62:
#line 378 "unix/tg_parser.y"
    { rsvp = false; }
    break;

  case 63:
#line 382 "unix/tg_parser.y"
    { rsvpSignalWaitTime = yy_timeval; }
    break;

  case 64:
#line 386 "unix/tg_parser.y"
    { rsvpSyncBackoffTime = yy_timeval; }
    break;

  case 65:
#line 387 "unix/tg_parser.y"
    { rsvpSyncBackoffTime = TimeValue(-1,-1); }
    break;

  case 67:
#line 392 "unix/tg_parser.y"
    { TSpec x; tspec = x; }
    break;

  case 68:
#line 396 "unix/tg_parser.y"
    { tspec.set_r(yy_float); }
    break;

  case 69:
#line 397 "unix/tg_parser.y"
    { tspec.set_r(yy_int); }
    break;

  case 70:
#line 401 "unix/tg_parser.y"
    { tspec.set_b(yy_float); }
    break;

  case 71:
#line 402 "unix/tg_parser.y"
    { tspec.set_b(yy_int); }
    break;

  case 72:
#line 406 "unix/tg_parser.y"
    { tspec.set_p(yy_float); }
    break;

  case 73:
#line 407 "unix/tg_parser.y"
    { tspec.set_p(yy_int); }
    break;

  case 74:
#line 411 "unix/tg_parser.y"
    { tspec.set_m(yy_int); }
    break;

  case 75:
#line 415 "unix/tg_parser.y"
    { tspec.set_M(yy_int); }
    break;

  case 76:
#line 419 "unix/tg_parser.y"
    { rsvp = true; wtpFactor = 1.0; }
    break;

  case 77:
#line 420 "unix/tg_parser.y"
    { rsvp = true; wtpFactor = 1.0; rspec.set_R(0); rspec.set_S(yy_int); }
    break;

  case 78:
#line 421 "unix/tg_parser.y"
    { rsvp = true; rspec.set_R(0); rspec.set_S(0); }
    break;

  case 79:
#line 422 "unix/tg_parser.y"
    { rsvp = false; }
    break;

  case 80:
#line 426 "unix/tg_parser.y"
    { rspec.set_R(yy_float); }
    break;

  case 81:
#line 427 "unix/tg_parser.y"
    { rspec.set_R(yy_int); }
    break;

  case 82:
#line 431 "unix/tg_parser.y"
    { rspec.set_S(yy_int); }
    break;

  case 83:
#line 435 "unix/tg_parser.y"
    { wtpFactor = yy_float; }
    break;

  case 84:
#line 436 "unix/tg_parser.y"
    { wtpFactor = yy_int; }
    break;

  case 85:
#line 437 "unix/tg_parser.y"
    { wtpFactor = 1.0; }
    break;

  case 86:
#line 441 "unix/tg_parser.y"
    { rateEstimator = (RateEstimator*)findSummaryObject( yy_string ); }
    break;

  case 87:
#line 442 "unix/tg_parser.y"
    { rateEstimator = NULL; }
    break;

  case 88:
#line 446 "unix/tg_parser.y"
    { delayCounter = (DelayCounter*)findSummaryObject( yy_string ); }
    break;

  case 89:
#line 447 "unix/tg_parser.y"
    { delayCounter = NULL; }
    break;

  case 90:
#line 451 "unix/tg_parser.y"
    { packetCounter = (PacketCounter*)findSummaryObject( yy_string ); }
    break;

  case 91:
#line 452 "unix/tg_parser.y"
    { packetCounter = NULL; }
    break;

  case 92:
#line 456 "unix/tg_parser.y"
    { packetSize = yy_int; }
    break;

  case 93:
#line 460 "unix/tg_parser.y"
    { packetRate = yy_int; }
    break;

  case 94:
#line 464 "unix/tg_parser.y"
    { totalSize = yy_int; }
    break;

  case 95:
#line 468 "unix/tg_parser.y"
    { sourceCount = yy_int; }
    break;

  case 96:
#line 472 "unix/tg_parser.y"
    { hurstParameter = yy_float; }
    break;

  case 97:
#line 476 "unix/tg_parser.y"
    { varTime = yy_timeval; }
    break;

  case 98:
#line 480 "unix/tg_parser.y"
    { varList.push_back( yy_int ); }
    break;

  case 99:
#line 481 "unix/tg_parser.y"
    { varList.push_back( yy_int ); }
    break;

  case 100:
#line 485 "unix/tg_parser.y"
    { flowArrival = yy_timeval; }
    break;

  case 101:
#line 489 "unix/tg_parser.y"
    { flowDuration = yy_timeval; }
    break;

  case 102:
#line 493 "unix/tg_parser.y"
    { fixedArrival = fixedDuration = true; }
    break;

  case 104:
#line 498 "unix/tg_parser.y"
    { fixedArrival = true; }
    break;

  case 105:
#line 499 "unix/tg_parser.y"
    { fixedArrival = false; }
    break;

  case 106:
#line 503 "unix/tg_parser.y"
    { fixedDuration = true; }
    break;

  case 107:
#line 504 "unix/tg_parser.y"
    { fixedDuration = false; }
    break;

  case 108:
#line 508 "unix/tg_parser.y"
    { yy_timeval = TimeValue(yy_int,0); }
    break;

  case 109:
#line 509 "unix/tg_parser.y"
    { yy_timeval.getFromFraction(yy_float); }
    break;

  case 110:
#line 513 "unix/tg_parser.y"
    { yy_ip_address = yy_string; }
    break;

  case 111:
#line 514 "unix/tg_parser.y"
    { findAlias( yy_string ); }
    break;

  case 112:
#line 518 "unix/tg_parser.y"
    { aliasList.push_back( Alias(yy_name,yy_ip_address) ); }
    break;

  case 113:
#line 522 "unix/tg_parser.y"
    { yy_name = yy_string; }
    break;

  case 114:
#line 526 "unix/tg_parser.y"
    { createSummaryObject( *new RateEstimator( yy_timeval, yy_string ) ); }
    break;

  case 115:
#line 530 "unix/tg_parser.y"
    { createSummaryObject( *new DelayCounter( yy_timeval, yy_int, yy_string ) ); }
    break;

  case 116:
#line 534 "unix/tg_parser.y"
    { createSummaryObject( *new PacketCounter( yy_string ) ); }
    break;


    }

/* Line 1000 of yacc.c.  */
#line 1906 "/home/oscars/dcn-software-suite-0.5.1/dragon/dragon-sw/kom-rsvp/gen/clients/tg_parser.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 537 "unix/tg_parser.y"


void yyerror(const char *s) {
	cerr << s << " in config file: " << configfile << " in line " << yylineno << endl;
	fatalError = true;
}

bool tg_parser_parse( const String& filename, RSVP_API* rapi = NULL ) {
	configfile = filename.chars();
	api = rapi;
	yyin = fopen( filename.chars(), "r" );
	if ( !yyin ) {
		cerr << "ERROR: cannot access configuration file " << filename << endl;
		exit(1);
	} else {
		yyparse();
		fclose( yyin );
	}
	return !fatalError;
}

