package net.es.oscars.policy.database;

import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.SQLQuery;

import net.es.oscars.aaa.Attribute;
import net.es.oscars.database.GenericHibernateDAO;

public class PolicyClassDAO extends GenericHibernateDAO<PolicyClass, Integer>{
    private Logger log;
    
    public PolicyClassDAO(String dbName){
        this.setDatabase(dbName);
        this.log = Logger.getLogger(this.getClass());
    }

    public List<PolicyClass> findByNameAttrs(List<String> names,
            List<Attribute> attrs) {
        String sql = "SELECT pc.* FROM policyClasses AS pc INNER JOIN " +
            "policyClassCriteria AS pcc ON pc.id=pcc.policyClassId WHERE ";
        if(!names.isEmpty()){
            sql += "(pcc.typeId=(SELECT id FROM policyClassCriterionTypes WHERE " +
            "name='NAME') AND (";
            boolean first = true;
            for(int i=0; i < names.size(); i++){
                if(first){
                    first = false;
                }else{
                    sql += " OR ";
                }
                sql += "value=?";
            }
            sql += "))";
        }
        
        if(attrs != null && (!attrs.isEmpty())){
            if(!names.isEmpty()){
                sql += " OR ";
            }
            sql += "(pcc.typeId=(SELECT id FROM policyClassCriterionTypes WHERE " +
            "name='ATTR_ROLE') AND (";
            boolean first = true;
            for(int i=0; i < attrs.size(); i++){
                if(first){
                    first = false;
                }else{
                    sql += " OR ";
                }
                sql += "value=?";
            }
            sql += "))";
        }
        
        SQLQuery query = this.getSession().createSQLQuery(sql).addEntity(PolicyClass.class);
        for(int i=0; i < names.size(); i++){
            query.setString(i, names.get(i));
        }
        if(attrs != null){
            int i = names.size();
            for(Attribute attr : attrs){
                if(!"role".equals(attr.getAttrType())){
                    continue;
                }
                query.setString(i, attr.getName());
                i++;
            }
        }
        
        return query.list();
    }
}
