package net.es.oscars.policy.rmi;

import java.io.PrintStream;
import java.rmi.Remote;
import java.rmi.RemoteException;

import org.w3c.dom.Element;

import net.es.oscars.policy.client.CheckPolicyRequest;
import net.es.oscars.policy.client.CheckPolicyResponse;
import net.es.oscars.policy.client.DOMRequester;

/**
 * The RMI interface to the core.
 * 
 * @author Andrew Lake (alake@internet2.edu)
 */
public interface PolicyRmiInterface extends Remote{
    public static String registeredServerName = "net.es.oscars.rmi.policy";
    
    /**
     * Checks whether a particular action is allown on a resource by a 
     * requester(s). Uses W3C DOM elements to represent information which 
     * are Serializable. 
     * 
     * @param request the check policy request
     * @return the response to the policy request
     * @throws RemoteException
     */
    public CheckPolicyResponse checkPolicy(CheckPolicyRequest<DOMRequester,Element[]> request) throws RemoteException;
    
    public void loadPolicy(String filename, Boolean verbose) throws RemoteException;
}
